# Generated by Django 3.2.12 on 2022-06-26 20:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Dataset',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=50)),
                ('source', models.CharField(max_length=50)),
                ('description', models.TextField()),
                ('order', models.IntegerField(default=999)),
                ('stored_at', models.CharField(choices=[('LOCAL_POSTGRES', 'Local PostgreSQL instance')], default='LOCAL_POSTGRES', max_length=32)),
                ('table_name', models.CharField(max_length=50)),
                ('private', models.BooleanField(default=False)),
                ('spatialEast', models.FloatField(blank=True, null=True)),
                ('spatialSouth', models.FloatField(blank=True, null=True)),
                ('spatialNorth', models.FloatField(blank=True, null=True)),
                ('spatialWest', models.FloatField(blank=True, null=True)),
                ('temporalCoverageBegin', models.DateTimeField(blank=True, null=True)),
                ('temporalCoverageEnd', models.DateTimeField(blank=True, null=True)),
                ('license', models.CharField(blank=True, max_length=200, null=True)),
                ('observations', models.CharField(blank=True, max_length=200, null=True)),
                ('publisher', models.TextField(blank=True, null=True)),
                ('category', models.CharField(blank=True, max_length=200, null=True)),
                ('update_frequency', models.CharField(default='-', max_length=200)),
                ('last_updated', models.DateTimeField(blank=True, null=True)),
                ('metadata', models.JSONField(default=dict)),
                ('hidden', models.BooleanField(default=False)),
                ('owner', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='datasets', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'ordering': ['order', '-id'],
            },
        ),
        migrations.CreateModel(
            name='Variable',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('title', models.CharField(max_length=50)),
                ('unit', models.CharField(max_length=50)),
                ('description', models.TextField(null=True)),
                ('dataType', models.CharField(max_length=50, null=True)),
                ('dataset', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='variables', to='aggregator.dataset')),
            ],
            options={
                'ordering': ['title'],
            },
        ),
        migrations.CreateModel(
            name='Dimension',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('title', models.CharField(max_length=50)),
                ('unit', models.CharField(max_length=50)),
                ('description', models.TextField(null=True)),
                ('dataType', models.CharField(max_length=50, null=True)),
                ('variable', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='dimensions', to='aggregator.variable')),
            ],
            options={
                'ordering': ['pk'],
            },
        ),
    ]
