# -*- coding: utf-8 -*-
from __future__ import unicode_literals
import json
import re
from threading import Thread
from django.db import models
import copy
from aggregator.models import *
from query_designer.query_processors.utils import SolrResultEncoder, PostgresResultEncoder, PrestoResultEncoder
from django.http import JsonResponse

class DataExplorationService(models.Model):
    uObfuscated = models.ForeignKey(User, related_name='qrs', on_delete=models.CASCADE, null=True, default=None)
    tObfuscated = models.CharField(default='Uq', max_length=50)
    cObfuscated = models.DateTimeField(auto_now_add=True)
    udtObfuscated = models.DateTimeField(auto_now=True)
    dObfuscated = models.JSONField()

    @staticmethod
    def o2sObfuscated(op, m='postgres'):
        if m == 'postgres':
            return {
                'eq': ('=', ':'), 'neq': ('!=', None), 'gt': ('>', None), 'gte': ('>=', None),
                'lt': ('<', None), 'lte': ('<=', None), 'mod': ('%', None),
                'lte_time': ('<=', None), 'gte_time': ('>=', None),
                '&&': ('AND', 'AND'), 'and': ('AND', 'AND'),
                '||': ('OR', 'OR'), 'or': ('OR', 'OR'),
                '!': ('NOT', None), 'not': ('NOT', None),
            }[op.lower()][0 if m == 'postgres' else 1]
        elif m == 'presto':
            return {
                'eq': ('=', ':'), 'neq': ('!=', None), 'gt': ('>', None), 'gte': ('>=', None),
                'lt': ('<', None), 'lte': ('<=', None), 'mod': ('%', None),
                'lte_time': ('<= timestamp', None), 'gte_time': ('>= timestamp', None),
                '&&': ('AND', 'AND'), 'and': ('AND', 'AND'),
                '||': ('OR', 'OR'), 'or': ('OR', 'OR'),
                '!': ('NOT', None), 'not': ('NOT', None),
            }[op.lower()][0 if m == 'presto' else 1]
        else:
            return {
                'not_null': (' IS NOT NULL ', None),
                'eq': ('=', ':'), 'neq': ('!=', None), 'gt': ('>', None), 'gte': ('>=', None),
                'lt': ('<', None), 'lte': ('<=', None), 'mod': ('%', None),
                'lte_time': ('<= ', None), 'gte_time': ('>= ', None),
                '&&': ('AND', 'AND'), 'and': ('AND', 'AND'),
                '||': ('OR', 'OR'), 'or': ('OR', 'OR'),
                '!': ('NOT', None), 'not': ('NOT', None),
            }[op.lower()][0 if m == 'presto' else 1]

    def pf(self, f, m='postgres', q=False, utn=False):
        if isinstance(f, (int, float)):
            try:
                cn = ''
                fo = int(f[f.find('i')+1:f.find('_')])
                if fo >= 0:
                    tn = self.d['from'][fo]['name']
                    for x in self.d['from'][fo]['select']:
                        if x['name'] == f:
                            if x['type'] != 'VALUE':
                                cn = Dimension.objects.get(pk=x['type']).name
                            else:
                                vo = Variable.objects.get(pk=int(self.d['from'][fo]['type']))
                                cn = vo.name
                    if utn:
                        f = tn + '."' + cn + '"'
                    else:
                        f = cn
            except:
                return f
            return f